import express from 'express';
export interface IResponse {
    data: any;
}
export declare class Response<T extends IResponse> {
    data: any;
}
export declare abstract class BaseController {
    constructor();
    abstract execute(request: express.Request, response: express.Response, next: express.NextFunction): Promise<void>;
    protected ok<T>(response: express.Response, data?: T): express.Response<IResponse>;
    protected created(response: express.Response): express.Response<any, Record<string, any>>;
    protected clientError(message?: string): void;
    protected unauthorized(message?: string): void;
    protected paymentRequired(message?: string): void;
    protected forbidden(message?: string): void;
    protected notFound(message?: string): void;
    protected conflict(message?: string): void;
    protected tooMany(message?: string): void;
    protected internalError(message?: string): void;
}
