import nconf from 'nconf';
import { Environment } from '../';
export declare type NCONF = typeof nconf;
export interface DefaultConfig {
    prodConfig: Record<string, any>;
    stagingConfig?: Record<string, any>;
    devConfig?: Record<string, any>;
    testConfig?: Record<string, any>;
}
export declare abstract class Config {
    constructor();
    abstract get nconf(): NCONF;
    abstract set(environment: Environment, config: DefaultConfig): void;
}
export declare class Nconf extends Config {
    private static _instance;
    private _nconf;
    private isRequired;
    private constructor();
    get nconf(): typeof nconf;
    static getInstance(): Nconf;
    set(environment: Environment, config: DefaultConfig): void;
}
