"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserMiddleware = exports.keycloakConfig = void 0;
var fs_1 = __importDefault(require("fs"));
var path_1 = require("path");
var __1 = require("..");
function keycloakConfig(realm, authUrl, clientId, clientSecret, username, password) {
    var keycloak = require('keycloak-backend')({
        "realm": realm,
        "auth-server-url": authUrl,
        "client_id": clientId,
        "client_secret": clientSecret,
        "username": username,
        "password": password
    });
    return keycloak;
}
exports.keycloakConfig = keycloakConfig;
;
;
;
;
var UserMiddleware = /** @class */ (function () {
    function UserMiddleware() {
    }
    ;
    UserMiddleware.getInstance = function () {
        if (!UserMiddleware._instance)
            UserMiddleware._instance = new UserMiddleware();
        return UserMiddleware._instance;
    };
    ;
    UserMiddleware.prototype.currentUser = function (req, res, next) {
        return __awaiter(this, void 0, void 0, function () {
            var token, bearerToken, nconf, keycloak, cert, user, payload, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        token = void 0;
                        bearerToken = req.header('Authorization');
                        if (bearerToken && bearerToken.startsWith('Bearer ')) {
                            token = bearerToken.substring(7, bearerToken.length);
                        }
                        else {
                            token = bearerToken;
                        }
                        ;
                        if (!token)
                            throw new __1.GenericValidationError({ error: new Error('Access denied. No token provided.'), errorCode: 401 });
                        nconf = __1.Nconf.getInstance().nconf;
                        keycloak = keycloakConfig(nconf.get('realm'), nconf.get('authUrl'), nconf.get('clientId'), nconf.get('clientSecret'), nconf.get('keycloakUsername'), nconf.get('keycloakPassword'));
                        cert = fs_1.default.readFileSync((0, path_1.join)(__dirname, '../public.pem'));
                        return [4 /*yield*/, keycloak.jwt.verifyOffline(token, cert)];
                    case 1:
                        user = _a.sent();
                        payload = user.content;
                        res.locals.currentUser = payload;
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _a.sent();
                        return [2 /*return*/, next()];
                    case 3:
                        next();
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    return UserMiddleware;
}());
exports.UserMiddleware = UserMiddleware;
;
